#include<iostream>
#include<vector>
#include<cstring>
using namespace std;
const int MAX_N=1e5+4;
int pos[MAX_N];
int tree[4*MAX_N];
int Left[MAX_N];
int Right[MAX_N];
int MaxH;
vector<int>ans;
void Update(int node,int l,int r,int idx,int st)
{
    if(l>idx or r<idx)return;
    if(l==r)
    {
        tree[node]=st;
        return;
    }
    int mid=(l+r)/2;
    Update(2*node,l,mid,idx,st);
    Update(2*node+1,mid+1,r,idx,st);
    tree[node]=max(tree[2*node],tree[2*node+1]);
}
int Query(int node,int l,int r,int ql,int qr)
{
    if(l>qr or r<ql)return -1;
    if(ql<=l && r<=qr)
    {
        return tree[node];
    }
    int mid=(l+r)/2;
    return max(Query(2*node,l,mid,ql,qr),
               Query(2*node+1,mid+1,r,ql,qr));
}
vector <int> calc(int n, vector <int>&h, vector <int>&c)
{
    for(int i=0;i<n;i++)
    {
        h[i]++;
        MaxH=max(MaxH,h[i]);
    }
    ///in

    for(int i=n-1;i>=0;i--)
    {
        Right[i+1]=Query(1,1,MaxH,1,h[i]);
        if(i+1>pos[h[i]])
        {
            Update(1,1,MaxH,h[i],i+1);
            pos[h[i]]=i+1;
        }
    }
    ///Right

    memset(pos,0,sizeof(pos));
    memset(tree,0,sizeof(tree));
    for(int i=0;i<n;i++)
    {
        Left[i+1]=Query(1,1,MaxH,1,h[i]);
        if(i+1>pos[h[i]])
        {
            Update(1,1,MaxH,h[i],i+1);
            pos[h[i]]=i+1;
        }
    }
    ///Left

    for(int i=1;i<=n;i++)
    {
        if(Left[i]==0)
        {
            ans.push_back(Right[i]);
            continue;
        }
        if(Right[i]==0)
        {
            ans.push_back(Left[i]);
            continue;
        }
        if(i-Left[i]>=Right[i]-i)
        {
            ans.push_back(Left[i]);
        }
        else ans.push_back(Right[i]);
    }

    return ans;
}
