#include<iostream>
#include<vector>
#include<cstring>
using namespace std;
const int MAX_N=1e6+3;
int pos[MAX_N];
int tree[4*MAX_N];
int Left[MAX_N];
int Right[MAX_N];
int MaxH;
vector<int>ans;
void Update(int node,int l,int r,int idx,int st,bool m)
{
    if(l>idx or r<idx)return;
    if(l==r)
    {
        tree[node]=st;
        return;
    }
    int mid=(l+r)/2;
    Update(2*node,l,mid,idx,st,m);
    Update(2*node+1,mid+1,r,idx,st,m);
    if(m==0)tree[node]=max(tree[2*node],tree[2*node+1]);
    else tree[node]=min(tree[2*node],tree[2*node+1]);
}
int Query(int node,int l,int r,int ql,int qr,bool m)
{
    if(l>qr or r<ql)
    {
        if(m==0)return -1;
        else return 1e9;
    }
    if(ql<=l && r<=qr)
    {
        return tree[node];
    }
    int mid=(l+r)/2;
    if(m==0)return max(Query(2*node,l,mid,ql,qr,m),
               Query(2*node+1,mid+1,r,ql,qr,m));
    else return min(Query(2*node,l,mid,ql,qr,m),
               Query(2*node+1,mid+1,r,ql,qr,m));
}
vector <int> calc(int n, vector <int>&h, vector <int>&c)
{
    for(int i=0;i<n;i++)
    {
        h[i]++;
        MaxH=max(MaxH,h[i]);
    }
    ///in

    for(int i=n-1;i>=0;i--)
    {
        Right[i+1]=Query(1,1,MaxH,1,h[i],0);
        if(i+1>pos[h[i]])
        {
            Update(1,1,MaxH,h[i],i+1,0);
            pos[h[i]]=i+1;
        }
    }
    ///Right

    memset(pos,0,sizeof(pos));
    memset(tree,0,sizeof(tree));
    for(int i=1;i<=MaxH;i++)
    {
        pos[i]=1e9;
        Update(1,1,MaxH,i,1e9,1);
    }
    for(int i=0;i<n;i++)
    {
        Left[i+1]=Query(1,1,MaxH,1,h[i],1);
        if(Left[i+1]==1e9)Left[i+1]=0;
        if(i+1<pos[h[i]])
        {
            Update(1,1,MaxH,h[i],i+1,1);
            pos[h[i]]=i+1;
        }
    }
    ///Left

    for(int i=1;i<=n;i++)
    {
        //cout<<Left[i]<<" ";
        if(Left[i]==0)
        {
            ans.push_back(Right[i]);
            continue;
        }
        if(Right[i]==0)
        {
            ans.push_back(Left[i]);
            continue;
        }
        if(i-Left[i]>=Right[i]-i)
        {
            ans.push_back(Left[i]);
        }
        else ans.push_back(Right[i]);
    }
    //vector<int>ako;
    return ans;
}
