#include<bits/stdc++.h>
using namespace std;

int haha[2010][2010];
int yeah[2010][2010];
int px,py,cx,cy,n,m;

void coolthing(int x, int y, int v) {
    if(x < 0 || x >= n || y < 0 || y >= m || (haha[x][y] <= v && v != 0)) {
        return;
    }
    haha[x][y] = v;
    coolthing(x+1,y,v+1);
    coolthing(x-1,y,v+1);
    coolthing(x,y+1,v+1);
    coolthing(x,y-1,v+1);
}

bool dfs(int c) {
    queue<pair<int,int>> dude;
    dude.push({px,py});
    yeah[px][py] = c;
    int a,b;
    while(!dude.empty()) {
        a = dude.front().first;
        b = dude.front().second;
        if(a == cx && b == cy) {
            return true;
        }
        dude.pop();
        a++;
        if(a >= 0 && a < n && b >= 0 && b < m && haha[a][b] >= c && yeah[a][b] != c) {
            dude.push({a,b});
            yeah[a][b] = c;
        }
        a-=2;
        if(a >= 0 && a < n && b >= 0 && b < m && haha[a][b] >= c && yeah[a][b] != c) {
            dude.push({a,b});
            yeah[a][b] = c;
        }
        a++;
        b++;
        if(a >= 0 && a < n && b >= 0 && b < m && haha[a][b] >= c && yeah[a][b] != c) {
            dude.push({a,b});
            yeah[a][b] = c;
        }
        b-=2;
        if(a >= 0 && a < n && b >= 0 && b < m && haha[a][b] >= c && yeah[a][b] != c) {
            dude.push({a,b});
            yeah[a][b] = c;
        }
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    char a;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> a;
            if(a == '.') {
                haha[i][j] = INT_MAX;
            }
            else if(a == 'P') {
                px = i;
                py = j;
                haha[i][j] = INT_MAX;
            }
            else if(a == 'C') {
                cx = i;
                cy = j;
                haha[i][j] = INT_MAX;
            }
            else if(a == '+') {
                haha[i][j] = 0;
            }
        }
    }
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(haha[i][j] == 0) {
                coolthing(i,j,0);
            }
        }
    }
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            yeah[i][j] = -2;
        }
    }
    int l = -1,r = 2020,k;
    while(l < r) {
        k = (l+r+1)/2;
        if(dfs(k)) {
            l = k;
        }
        else {
            r = k-1;
        }
    }
    cout << l;
    return 0;
}
