#include<bits/stdc++.h>
//#include "Lgrader.cpp"
using namespace std;

struct Tree
{
    int value, color, index;
    Tree(){}
    Tree(int v, int c, int i)
        :value(v), color(c), index(i){}

    friend bool operator< (const Tree& A, const Tree& B)
    {
        if (A.value != B.value)
            return A.value < B.value;
        if (A.color != B.color)
            return A.color < B.color;
        return A.index < B.index;
    }

    friend bool operator> (const Tree& A, const Tree& B)
    {
        if (A.value != B.value)
            return A.value > B.value;
        if (A.color != B.color)
            return A.color > B.color;
        return A.index > B.index;
    }
};


vector <int> calc (int n, vector <int>& h, vector <int>& c)
{
    //70 points

    vector <int> ans(n);
    vector <int> ansL(n);
    vector <int> ansR(n);

    vector <Tree> sorted(n);

    for (int i = 0; i < n; i++)
    {
        sorted[i] = {h[i], c[i], i};
    }


    sort (sorted.begin(), sorted.end(), greater<Tree>());

    int currElement = 0;
    for (int i = n-1; i >= 0; i--)
    {
        while ((currElement < n) && ((h[i]<sorted[currElement].value) ||
                                     (h[i]==sorted[currElement].value && c[i] <= sorted[currElement].color)))
        {

            ansL[sorted[currElement].index] = i;
            currElement++;
        }
    }

    currElement = 0;
    for (int i = 0; i < n; i++)
    {
        while ((currElement < n) && ((h[i] < sorted[currElement].value)||
                                     (h[i]==sorted[currElement].value && c[i] <= sorted[currElement].color)))
        {
            ansR[sorted[currElement].index] = i;
            currElement++;
        }
    }

    for (int i = 0; i < n; i++)
    {
        int dist1 = ansL[i]-i;
        int dist2 = i-ansR[i];

        if (dist1 == 0 && dist2 == 0)
            ans[i] = 0;
        else if (dist1 > dist2)
            ans[i] = ansL[i]+1;
        else
            ans[i] = ansR[i]+1;
    }

    return ans;
}

/*
4
2 1
1 2
1 3
2 3
*/
