#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e3 + 10;
int n, ans, k, l, r, a[maxn], used[maxn], dp[maxn][maxn];

void read(){
    cin >> n >> k >> l >> r;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
    }
    sort(a + 1, a + n + 1);
}

void rec(int len, int last, int cnt, int idx){
    if(len == l){
        cnt++;
        len = 0;
        last = -1e9;
    }
    ans = max(ans, cnt);
    for(int i = idx + 1;i <= n;i++){
        if(!used[i]){
            if(a[i] - last >= k){
                used[i] = 1;
                rec(len + 1, a[i], cnt, i);
                used[i] = 0;
            }
        }
    }
}

int bins(int k){
    int l = 1, r = n;
    while(l <= r){
        int mid = (l + r) / 2;
        if(a[mid] == k){
            return mid;
        }
        if(a[mid] > k) r = mid - 1;
        else l = mid + 1;
    }
    return (l + r) / 2;
}


void otg(int t){
    memset(used, 0, sizeof(used));
    int cnt = 0;
    for(int i = 1;i <= n;i++){
        if(used[i]) continue;
        used[i] = 1;
        int br = 1, last = i;
        while(br < t){
            int idx = bins(a[last] + k);
            while(idx <= n && used[idx]){
                idx++;
            }
            if(idx == n + 1 || a[idx] - a[last] < k) break;
            used[idx] = 1;
            last = idx;
            br++;
        }
        if(br < t) break;
        cnt++;
    }
    cout << cnt << " ";

}

void solve(){
    if(l == r && n <= 10){
        rec(0, -1e9, 0, 0);
        cout << ans << endl;
        return;
    }

}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
