#include<bits/stdc++.h>
using namespace std;
struct edge
{
    long long i,j;
    edge() {}
    edge(long long _i,long long _j)
    {
        i=_i;
        j=_j;
    }
    edge operator+(edge e)
    {
        edge h;
        h.i=i+e.i;
        h.j=j+e.j;
        return h;
    }
};
long long n,m;
char a[2048][2048];
edge start,finish;
long long cl[2048][2048];
bool usedb[2048][2048];
edge dir[4]= {{1,0},{0,1},{-1,0},{0,-1}};
bool inRange(edge e)
{
    if(e.i>n||e.i<1||e.j>m||e.j<1)return 0;
    return 1;
}
void BFS(edge e)
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            long long help=abs(i-e.i)+abs(j-e.j);
            if(cl[i][j]==0&&(i!=e.i||j!=e.j))
            {
                cl[i][j]=help;
            }
            else cl[i][j]=min(cl[i][j],help);
        }
    }
}
void read()
{
    cin>>n>>m;
    for(long long i=1; i<=n; i++)
    {
        for(long long j=1; j<=m; j++)
        {
            cin>>a[i][j];
            edge e(i,j);
            if(a[i][j]=='P')start=e;
            if(a[i][j]=='C')finish=e;
        }
    }
    for(long long i=1; i<=n; i++)
    {
        for(long long j=1; j<=m; j++)
        {
            edge e(i,j);
            if(a[i][j]=='+')BFS(e);
        }
    }
}
void printcl()
{
    for(long long i=1; i<=n; i++)
    {
        for(long long j=1; j<=m; j++)
        {
            if(a[i][j]=='+')cl[i][j]=0;
            //cl[i][j]--;
            //cout<<cl[i][j]<<" ";
        }
        //cout<<endl;
    }
}
bool pos;
long long ans;

bool usedd[2048][2048];
void DFS(edge e,long long x)
{
    usedd[e.i][e.j]=1;
    if(e.i==finish.i&&e.j==finish.j)pos=1;
    if(pos)return;
    for(long long i=0; i<4; i++)
    {
        edge nb=e+dir[i];
        if(inRange(nb)&&cl[nb.i][nb.j]>=x&&!usedd[nb.i][nb.j])DFS(nb,x);
    }
}
bool check(long long x)
{
    memset(usedd,0,sizeof(usedd));
    pos=0;
    if(cl[start.i][start.j]>=x)DFS(start,x);
    if(pos)return 1;
    return 0;
}
void solve()
{
    long long l=0,r=n+m;
    while(l<=r)
    {
        long long m=(l+r)/2;
        if(check(m))
        {
            l=m+1;
            ans=max(ans,m);
        }
        else r=m-1;
    }
    cout<<ans<<endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    printcl();
    solve();
    return 0;
}
