#include<iostream>
#include<bits/stdc++.h>
using namespace std;
char tab[2010][2010];
int paths[2010][2010];
int mins[2010][2010];
bool v[2010][2010];
bool v2[2010][2010];
pair<int,int> dirs[4]={{-1,0},{0,-1},{0,1},{1,0}};
queue<pair<int,int>> q;
void bfs(int n, int m)
{
    while(!q.empty())
    {
        pair<int,int> curr=q.front();
        q.pop();
        for(auto dir : dirs)
        {
            int ni=curr.first+dir.first;
            int nj=curr.second+dir.second;
            if(ni==0 || nj==0 || ni>n || nj>m)continue;
            if(paths[ni][nj]==0 && tab[ni][nj]!='+'){paths[ni][nj]=paths[curr.first][curr.second]+1;}
            else
            {
                int best;
                if(paths[ni][nj]<=paths[curr.first][curr.second]+1)best=paths[ni][nj];
                else best=paths[curr.first][curr.second]+1;
                paths[ni][nj]=best;
            }
            if(v[ni][nj]==0 && tab[ni][nj]=='.'){q.push({ni,nj});v[ni][nj]=1;}
        }
    }
}
void bfs2(int n, int m)
{
    while(!q.empty())
    {
        pair<int,int> curr=q.front();
        q.pop();
        for(auto dir : dirs)
        {
            int ni=curr.first+dir.first;
            int nj=curr.second+dir.second;
            if(ni==0 || nj==0 || ni>n || nj>m)continue;
            if(mins[ni][nj]==0)mins[ni][nj]=min(paths[ni][nj],mins[curr.first][curr.second]);
            //else mins[ni][nj]=max(mins[ni][nj],mins[curr.first][curr.second]);
            if(v2[ni][nj]==0 && tab[ni][nj]=='.'){q.push({ni,nj});v2[ni][nj]=1;}
        }
    }
}
int main()
{
    int n,m,si,sj,ei,ej;
    string line;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        cin>>line;
        for(int j=0;j<m;j++)
        {
            tab[i][j+1]=line[j];
            if(line[j]=='+'){q.push({i,j+1});v[i][j+1]=1;}
            if(line[j]=='P'){si=i;sj=j+1;}
            if(line[j]=='C'){ei=i;ej=j+1;}
        }
    }
    //cout<<q.size()<<"f\n";
    bfs(n,m);
    /*cout<<"------------------\n";
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cout<<paths[i][j]<<" ";
        }
        cout<<"\n";
    }*/
    q.push({si,sj});
    mins[si][sj]=INT_MAX;
    v2[si][sj]=1;
    bfs2(n,m);
    mins[si][sj]=0;
    /*cout<<"------------------\n";
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cout<<mins[i][j]<<" ";
        }
        cout<<"\n";
    }*/
    //cout<<ei<<" "<<ej<<"\n";
    cout<<mins[ei][ej]<<"\n";
}