#include<bits/stdc++.h>
using namespace std;

int haha[2010][2010];
int yeah[2010][2010];
int px,py,cx,cy,n,m;

bool dfs(int c) {
    if(haha[px][py] < c) {
        return false;
    }
    queue<pair<int,int>> dude;
    dude.push({px,py});
    yeah[px][py] = c;
    int a,b;
    while(!dude.empty()) {
        a = dude.front().first;
        b = dude.front().second;
        if(a == cx && b == cy) {
            return true;
        }
        a++;
        if(a >= 0 && a < n && b >= 0 && b < m && haha[a][b] >= c && yeah[a][b] != c) {
            dude.push({a,b});
            yeah[a][b] = c;
        }
        a-=2;
        if(a >= 0 && a < n && b >= 0 && b < m && haha[a][b] >= c && yeah[a][b] != c) {
            dude.push({a,b});
            yeah[a][b] = c;
        }
        a++;
        b++;
        if(a >= 0 && a < n && b >= 0 && b < m && haha[a][b] >= c && yeah[a][b] != c) {
            dude.push({a,b});
            yeah[a][b] = c;
        }
        b-=2;
        if(a >= 0 && a < n && b >= 0 && b < m && haha[a][b] >= c && yeah[a][b] != c) {
            dude.push({a,b});
            yeah[a][b] = c;
        }
        dude.pop();
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    char a;
    queue<pair<int,int>> bfs;
    int c,d,e,f;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> a;
            if(a == '.') {
                haha[i][j] = INT_MAX;
            }
            else if(a == 'P') {
                px = i;
                py = j;
                haha[i][j] = INT_MAX;
            }
            else if(a == 'C') {
                cx = i;
                cy = j;
                haha[i][j] = INT_MAX;
            }
            else if(a == '+') {
                haha[i][j] = 0;
                bfs.push({i,j});
            }
        }
    }
    while(!bfs.empty()) {
        c = bfs.front().first;
        d = bfs.front().second;
        bfs.pop();
        e = c+1;
        f = d;
        if(e >= 0 && e < n && f >= 0 && f < m && haha[e][f] == INT_MAX) {
            haha[e][f] = haha[c][d]+1;
            bfs.push({e,f});
        }
        e = c;
        f = d+1;
        if(e >= 0 && e < n && f >= 0 && f < m && haha[e][f] == INT_MAX) {
            haha[e][f] = haha[c][d]+1;
            bfs.push({e,f});
        }
        e = c-1;
        f = d;
        if(e >= 0 && e < n && f >= 0 && f < m && haha[e][f] == INT_MAX) {
            haha[e][f] = haha[c][d]+1;
            bfs.push({e,f});
        }
        e = c;
        f = d-1;
        if(e >= 0 && e < n && f >= 0 && f < m && haha[e][f] == INT_MAX) {
            haha[e][f] = haha[c][d]+1;
            bfs.push({e,f});
        }
    }
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            yeah[i][j] = -2;
        }
    }
    int l = -1,r = 4040,k;
    while(l < r) {
        k = (l+r+1)/2;
        if(dfs(k)) {
            l = k;
        }
        else {
            r = k-1;
        }
    }
    cout << l;
    return 0;
}
