#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn=2048;
int n,m;

struct Point
{
    int x,y;
    Point(){};
    Point(int xi, int yi)
    {
        x=xi;
        y=yi;
    }
    bool is_valid()
    {
        return x>=1&&x<=n&&y>=1&&y<=m;
    }
};

char a[maxn][maxn];
int b[maxn][maxn],used[maxn][maxn];
Point p_pos,c_pos;
Point dir[4]={{1,0},{0,1},{-1,0},{0,-1}};
bool f;

void read()
{
    cin >> n >> m;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin >> a[i][j];
            if(a[i][j]=='P')
            {
                p_pos.x=i;
                p_pos.y=j;
            }
            if(a[i][j]=='C')
            {
                c_pos.x=i;
                c_pos.y=j;
            }
            if(a[i][j]=='+') b[i][j]=1;
        }
    }
}

void pre(long long ch)
{
    ch--;
    memset(used,0,sizeof(used));
    int up,down,left,right;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(b[i][j])
            {
                up=i-ch;
                down=i+ch;
                left=j-ch;
                right=j+ch;
                if(up<1) up=1;
                if(left<1) left=1;
                if(down>n) down=n;
                if(right>m) right=m;
                for(int q=up;q<=down;q++)
                {
                    for(int z=left;z<=right;z++)
                    {
                        used[q][z]=2;
                    }
                }
                used[i][j]=2;
            }
        }
    }
}

void BFS(int begi, int begj)
{
    used[begi][begj]=1;
    queue<Point>q;
    q.push({begi,begj});
    Point w,nb;
    while(!q.empty())
    {
        w=q.front();
        q.pop();
        for(int i=0;i<4;i++)
        {
            nb.x=w.x+dir[i].x;
            nb.y=w.y+dir[i].y;
            if(nb.is_valid()&&!used[nb.x][nb.y])
            {
                used[nb.x][nb.y]=1;
                q.push(nb);
            }
        }
    }

}

/*void print()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cout << used[i][j] << " ";
        }
        cout << endl;
    }
    cout << "++++++++++++++++++++" << endl;
}*/

void DFS(int begi, int begj)
{
    if(f) return;
    used[begi][begj]=1;
    if(begi==c_pos.x&&begj==c_pos.y)
    {
        f=true;
        return;
    }
    Point nb;
    for(int i=0;i<8;i++)
    {
        nb.x=begi+dir[i].x;
        nb.y=begj+dir[i].y;
        if(nb.is_valid()&&!used[nb.x][nb.y]) DFS(nb.x,nb.y);
        if(f) return;
    }
}
bool check(long long x)
{
    //if(x==0) return true;
    pre(x);
    if(used[p_pos.x][p_pos.y]==2||used[c_pos.x][c_pos.y]==2) return false;
    //print();
    f=false;
    BFS(p_pos.x, p_pos.y);
    //cout << "&&&&&&&&&&&&&" << endl;
    //print();
    return used[c_pos.x][c_pos.y]==1;
}
void solve()
{
    long long l=0,r=2048;
    long long mid,ans=0;
    while(l<=r)
    {
        mid=(l+r)/2;
        if(check(mid))
        {
            ans=max(ans,mid);
            l=mid+1;
        }
        else r=mid-1;
    }
    cout << ans << endl;
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
	solve();
return 0;
}
