#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 2005;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m;
char a[MAXN][MAXN];
struct cell
{
    int x, y;
    cell(){};
    cell(int _x, int _y)
    {
        x = _x;
        y = _y;
    }
    cell operator+(cell w)
    {
        cell ans = cell(x + w.x, y + w.y);
        return ans;
    }
    bool in_range()
    {
        return(x >= 1 && x <= n && y >= 1 && y <= m);
    }
};
cell st, fi;
cell dir[4]{{-1, 0}, {1, 0}, {0, -1}, {0, 1}};
vector < cell > v;
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> a[i][j];
            if(a[i][j] == 'P')st = cell(i, j);
            else if(a[i][j] == 'C')fi = cell(i, j);
            else if(a[i][j] == '+')v.push_back(cell(i, j));
        }
    }
}
int dist[MAXN][MAXN];
void init_dist()
{
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
            dist[i][j] = 1e9;
    }
}
int used[MAXN][MAXN];
void bfs(cell beg)
{
    memset(used, 0, sizeof(used));
    queue < cell > q;
    q.push(beg);
    dist[beg.x][beg.y] = 0;
    cell w;
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        for (int i = 0; i < 4; ++ i)
        {
            cell nb = w + dir[i];
            if(nb.in_range() && !used[nb.x][nb.y])
            {
                if(dist[nb.x][nb.y] > dist[w.x][w.y] + 1)
                {
                    dist[nb.x][nb.y] = dist[w.x][w.y] + 1;
                    used[nb.x][nb.y] = 1;
                q.push(nb);
                }
            }

        }
    }
    return;
}
void fill_dist()
{
    init_dist();
    int xx, yy;
    for (int i = 0; i < v.size(); ++ i)
    {
        xx = v[i].x;
        yy = v[i].y;
        bfs(v[i]);
    }
    /**for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
            cout << dist[i][j] << " ";
        cout << endl;
    }*/
}
bool check(int x)
{
    ///if(x == 3)cout << "here" << endl;
    memset(used, 0, sizeof(used));
    queue < cell > q;
    q.push(st);
    used[st.x][st.y] = 1;
    //if(dist[st.x][st.y] < x)return false;
    cell w, nb;
    while(!q.empty())
    {
        w = q.front();
       ///if(x == 3)cout << w.x << ", " << w.y << endl;
        q.pop();
        for (int i = 0; i < 4; ++ i)
        {
            nb = dir[i] + w;

            if(!nb.in_range())
            {
                ///if(x == 3)cout << "cont " << nb.x << " - " << nb.y << endl;
                continue;
            }
            if(nb.x == st.x && nb.y == st.y)
                return true;
            if(!used[nb.x][nb.y] && dist[nb.x][nb.y] >= x)
            {
                ///if(x == 3)cout << nb.x << " " << nb.y << endl;
                used[nb.x][nb.y] = 1;
                if(nb.x == st.x && nb.y == st.y)return true;
                q.push(nb);
            }
        }
    }
    ///if(x == 3)cout << "not ok" << endl;
    return false;
}
void bin_search()
{
    int left = 0, right = 5000, ans = 5000, mid;
    while(left <= right)
    {
        mid = (left + right)/2;
        if(check(mid))
        {
            ans = min(ans, mid);
            left = mid + 1;
        }
        else right = mid - 1;
    }
    cout << ans << endl;
}
int main()
{
    speed();

    read();
    fill_dist();
    bin_search();
}
