#include<bits/stdc++.h>
using namespace std;
struct edge
{
    int i,j;
    edge() {}
    edge(int _i,int _j)
    {
        i=_i;
        j=_j;
    }
    edge operator+(edge e)
    {
        edge h;
        h.i=i+e.i;
        h.j=j+e.j;
        return h;
    }
};
int n,m;
char a[2048][2048];
edge start,finish;
int cl[2048][2048];
bool usedb[2048][2048];
edge dir[4]= {{1,0},{0,1},{-1,0},{0,-1}};
bool inRange(edge e)
{
    if(e.i>n||e.i<1||e.j>m||e.j<1)return 0;
    return 1;
}
void BFS(edge e)
{
    memset(usedb,0,sizeof(usedb));
    queue<pair<edge,int> > q;
    q.push(make_pair(e,1));
    usedb[e.i][e.j]=1;
    while(!q.empty())
    {
        pair<edge,int> p=q.front();
        //cout<<p.first.i<<" "<<p.first.j<<endl;
        q.pop();
        //cout<<q.size()<<endl;
        for(int i=0; i<4; i++)
        {
            edge help=dir[i]+p.first;
            //cout<<help.i<<" "<<help.j<<endl;
            pair<edge,int> nb(help,p.second+1);

            if(inRange(help)&&!usedb[help.i][help.j])
            {
                if(a[help.i][help.j]!='+')
                {
                    //cout<<help.i<<" "<<help.j<<endl;
                    if(cl[help.i][help.j]==0)cl[help.i][help.j]=nb.second;
                    else cl[help.i][help.j]=min(nb.second,cl[help.i][help.j]);
                }
                usedb[help.i][help.j]=1;
                //cout<<nb.first.i<<" "<<nb.first.j<<" "<<nb.second<<endl;
                q.push(nb);
            }
        }
    }
}
void read()
{
    cin>>n>>m;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin>>a[i][j];
            edge e(i,j);
            if(a[i][j]=='P')start=e;
            if(a[i][j]=='C')finish=e;
        }
    }
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            edge e(i,j);
            if(a[i][j]=='+')BFS(e);
        }
    }
}
void printcl()
{
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cl[i][j]--;
            //cout<<cl[i][j]<<" ";
        }
        //cout<<endl;
    }
}
bool pos;
int ans;

bool usedd[2048][2048];
void DFS(edge e,int x)
{
    usedd[e.i][e.j]=1;
    if(e.i==finish.i&&e.j==finish.j)pos=1;
    if(pos)return;
    for(int i=0; i<4; i++)
    {
        edge nb=e+dir[i];
        if(inRange(nb)&&cl[nb.i][nb.j]>=x&&!usedd[nb.i][nb.j])DFS(nb,x);
    }
}
bool check(int x)
{
    memset(usedd,0,sizeof(usedd));
    pos=0;
    DFS(start,x);
    if(pos)return 1;
    return 0;
}
void solve()
{
    int l=0,r=4000;
    while(l<=r)
    {
        int m=(l+r)/2;
        if(check(m))
        {
            l=m+1;
            ans=max(ans,m);
        }
        else r=m-1;
    }
    cout<<ans<<endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    printcl();
    solve();
    return 0;
}
